<template>
  <section 
    id="events"
    class="container mx-auto h-2/3">
    <h2
      class="section-title">
      Eventos
    </h2>
    <swiper
      :options="swiperOptions">
      <swiperSlide
        v-for="e of events"
        :key="e.text"
        class="mb-10">
        <Event :title="e.title" :image="e.image" :text="e.text" />
      </swiperSlide>
      <div
        class="swiper-pagination"
        slot="pagination">
      </div>
    </swiper>
  </section>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import 'swiper/dist/css/swiper.css';
import { swiper, swiperSlide } from 'vue-awesome-swiper';

import Event, { IEvent } from '@/components/Event.vue';

interface Resolution {
  width: number;
  heigth: number;
}

@Component({
  components: {
    swiper,
    swiperSlide,
    Event,
  }
})
export default class Events extends Vue {
  window: Resolution = {
    width: 0,
    heigth: 0,
  };

  events: IEvent[] = [
    { title: 'Aula de História da Arte', image: 'historia-da-arte.jpg', text: 'Aulas destinadas exclusivamente ao desenvolvimento de boas práticas de escrita, estudo de temas e critérios de correção, oferecidas como parte do curso Regular.' },
    { title: 'Aulas de Obras literárias', image: 'obras-literarias.jpg', text: 'Palestras destinadas a estudo detalhado de leituras paradidáticas exigidas em grandes vestibulares, como Fuvest e Unicamp.' },
    { title: 'Oficinas de Redação', image: 'oficina-de-redacao.jpg', text: 'Aulas ministradas por professores candidatos, trazendo aos alunos uma visão multidisciplinar acerca de tópicos cada vez mais frequentes em provas importantes e extrapolando a abordagem conteudista de sala de aula.' },
  ];

  get swiperOptions(): any {
    return {
      slidesPerView: Math.floor(this.window.width / 350),
      spaceBetween: 30,
      initialSlide: 1,
      centeredSlides: true,
      pagination: {
        el: '.swiper-pagination',
        clickable: true
      }
    };
  }

  handleSize() {
    this.window.width = window.innerWidth;
    this.window.heigth = window.innerHeight;
  }

  created() {
    window.addEventListener('resize', this.handleSize)
    this.handleSize();
  }

  destroyed() {
    window.removeEventListener('resize', this.handleSize);
  }
}
</script>